;------------------------------------------------------------------------------
	include	<terminal_h.asm>
	include	<color_h.asm>
;------------------------------------------------------------------------------
SCR_WIDTH	equ	80
SCR_HEIGTH	equ	25
;------------------------------------------------------------------------------
;   (ASCIIZ)
; ......
; call __puts
; .db "",00h
; .....
__puts:
		pop	hl
.puts_loop:
		ld	a,(hl)
		or	a
		jr	z,	.puts_exit
		push	hl
		;
		call	__putc
		;
		pop	hl
		inc	hl
		jr	.puts_loop
.puts_exit:
		;    scroll?
		ld	a, 0xFE
		ld	(0x5C8C),a
		;
		inc	hl
		push	hl
		ret
;------------------------------------------------------------------------------
;   
__putc:
		; -- - --
		;  
		cp	#0A
		jr nz,	.no_newline
		jr	.next_line
		; 
.no_newline:	cp	#09
		jr nz,	.no_tab
		ld	a,(CON_X_POS)
		add	a,#08
		and	#F8
		jr	.next_pos
.no_tab:
		;  
		push	af
		;   Y
		ld	a,(CON_Y_POS)
		ld	l,a
		ld	h,0
		; HL = Y*64
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		;   X
		ld	a,(CON_X_POS)
		;    ( )
		ld	c,a
		srl	c
		ld	b,0
		add	hl,bc
		;   
		bit	0,a
		jr nz,	.no_chet
		;  
		ld	de,#41C0
		add	hl,de
		push	hl	;  
		ld	de,#A000
		add	hl,de   ;  
		pop	de
		jr	.put_sym
.no_chet:
		; ޣ 
		ld	de,#61C0
		add	hl,de
		push	hl	;  
		ld	de,#6001
		add	hl,de   ;  
		pop	de
.put_sym:	; de -  
		; hl - 
		pop	af
		ld	(de),a
		ld	a,(CON_COLOR)
		ld	(hl),a
		;  .
		ld	a,(CON_X_POS)
		inc	a
.next_pos:
		cp	SCR_WIDTH
		jr nc,	.next_line
		;
		ld	(CON_X_POS),a
		ret
.next_line:	;  
		xor	a
		ld	(CON_X_POS),a
		;
		ld	a,(CON_Y_POS)
		inc	a
		cp	SCR_HEIGTH
		jr nc,	.need_scroll
		ld	(CON_Y_POS),a
		ret
.need_scroll:	;  
		dec	a
		ld	(CON_Y_POS),a
		call	__scroll_up
		ret
;------------------------------------------------------------------------------
 IFNDEF	C_INC
	define C_INC TCOLOR_GREEN
 ENDIF
 IFNDEF	C_PAPER
	define C_PAPER	FCOLOR_BLACK
 ENDIF
 IFNDEF	C_BORDER
	define C_BORDER TCOLOR_BLACK
 ENDIF
;      ( 80x25 )
__init_screen:
		;   !
		in	a,(#BF)
		or	1
		out	(#BF),a	
		ld	bc,#FF77
		;  80x25
		ld	a,6
		out	(c),a	
		;   -  1   3 (,  ROM - 48K)
		;   -  5   1 (   )
		ld	a,#11
		ld	bc,#7FFD
		out	(c),a	
		;
		call	__font_init
		call	__clear_screen
		;
		ret
;------------------------------------------------------------------------------
;    256x192 (ZX)
__done_screen:
		in	a,(#BF)
		or	1
		out	(#BF),a		;   !
		ld	bc,#FF77
		ld	a,3
		out	(c),a	;       256x192
		ret
;------------------------------------------------------------------------------
;   ( -  A)  
; CF=0 -  
; CF=1 -   
__inkey:
		bit	5,(IY+01h)
		jr 	z,.nodata
		ld	a,(IY-50)
		res	5,(IY+01h)
		;
		scf	; CF=1
		ccf	; CF=0 (CF=!CF)
		ret
.nodata:
		scf	; CF=1
		ret
;------------------------------------------------------------------------------
;   ( -  A)
; ģ   
__inkeyw:
		call	__inkey
		jr	c,__inkeyw
		ret
;------------------------------------------------------------------------------
;  -   
__init_termio:
		di
		;   (  )
		ld	HL,2762h
		exx
		ld	IY,5C3Ah
		;  
		init_screen
		;
		ei
		ret
;------------------------------------------------------------------------------
CLEAR_SYM	equ	' '
__clear_screen:
		; //  (     01C0 - 07FF)
		ld	hl,#41C0
		ld	de,#41C1
		ld	bc,#63F
		ld	a,CLEAR_SYM
		ld	(hl),a
		ldir
		; //  (     21C0 - 27FF)
		ld	hl,#61C0
		ld	de,#61C1
		ld	bc,#63F
		ld	a,CLEAR_SYM
		ld	(hl),a
		ldir
		; //  (     01C0 - 07FF)
		ld	hl,#C1C0
		ld	de,#C1C1
		ld	bc,#63F
		ld	a,(CON_COLOR)
		ld	(hl),a
		ldir
		; //  (     21C0 - 27FF)
		ld	hl,#E1C0
		ld	de,#E1C1
		ld	bc,#63F
		ld	a,(CON_COLOR)
		ld	(hl),a
		ldir
		; 
		ld	a,C_BORDER
		out	(#FE),a
		;
		ret
;------------------------------------------------------------------------------
;      .
__scroll_up:
		; 
		;  .
		ld	hl,#41C0+#40
		ld	de,#41C0
		ld	bc,#640-#40
		ldir
		;   (  )
		ld	hl,#61C0+#40
		ld	de,#61C0
		ld	bc,#640-#40
		ldir
		;   
		ld	hl,#4800-#40
		ld	de,#4800-#3F
		ld	bc,#3F
		ld	a,CLEAR_SYM
		ld	(hl),a
		ldir
		;   
		ld	hl,#6800-#40
		ld	de,#6800-#3F
		ld	bc,#3F
		ld	a,CLEAR_SYM
		ld	(hl),a
		ldir
		; 
		;  .
		ld	hl,#C1C1+#40
		ld	de,#C1C1
		ld	bc,#640-#40
		ldir
		;   (  )
		ld	hl,#E1C0+#40
		ld	de,#E1C0
		ld	bc,#640-#40
		ldir
		;   
		ld	hl,#C801-#40
		ld	de,#C801-#3F
		ld	bc,#3F
		ld	a,(CON_CL_COLOR)
		ld	(hl),a
		ldir
		;   
		ld	hl,#E800-#40
		ld	de,#E800-#3F
		ld	bc,#3F
		ld	a,(CON_CL_COLOR)
		ld	(hl),a
		ldir
		;
		ret
;------------------------------------------------------------------------------
;    
; c - 
__set_ink:
		ld	a,(CON_COLOR)
		and	#FF-COLOR_INK_MASK
		or	c
		ld	(CON_COLOR),a
		ret
;------------------------------------------------------------------------------
;    
; c - 
__set_paper:
		ld	a,(CON_COLOR)
		and	#FF-COLOR_PAPER_MASK
		or	c
		ld	(CON_COLOR),a
		ret
;------------------------------------------------------------------------------
;   
;------------------------------------------------------------------------------
CON_X_POS	db	00	; X- ()
CON_Y_POS	db	00	; Y- ()
CON_COLOR	db	C_INC | C_PAPER	;  ()
CON_CL_COLOR	db	C_INC | C_PAPER	;  (   )
;------------------------------------------------------------------------------
; 
__font_init:
		di
		;   
		in	a,(#BF)
		or	4
		out	(#BF),a
		;     ,
		; ..  ӣ     
		; #4000 - #47FF
		ld	hl,fkoi8r8x8
		ld	de,#4000
		ld	bc,#800
		ldir
		;   
		in	a,(#BF)
		and	#FB
		out	(#BF),a
		;
		ret
;------------------------------------------------------------------------------
fkoi8r8x8:
		incbin "koi8r-8x8.bin"
;------------------------------------------------------------------------------
